//+------------------------------------------------------------------+
//|                                      MACD 2 Colour HISTOGRAM.mq4 |
//|                   Copyright  2006-07, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-07, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property link      "2 colour Histogram added by cja" 
 
#property  indicator_separate_window
#property  indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Coral
#property  indicator_color3  Aqua
#property  indicator_color4  Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 1

//---- indicator parameters
extern string note1 = "----------------------";
extern string note2 = "Fast Moving Average";
extern int FastMA=12;
extern string note3 = "0=Simple,1=Exponential";
extern string note4 = "2=Smooth,3=Linear Weighted";
extern int FastMA_Method=1;
extern string note5 = "----------------------";
extern string note6 = "Slow Moving Average";
extern int SlowMA=26;
extern string note7 = "0=Simple,1=Exponential";
extern string note8 = "2=Smooth,3=Linear Weighted";
extern int SlowMA_Method=1;
extern string note9 = "----------------------";
extern string note10 = "Signal Moving Average";
extern int SignalMA=9;
extern string note11 = "0=Simple,1=Exponential";
extern string note12 = "2=Smooth,3=Linear Weighted";
extern int SignalMA_Method=1;

//---- indicator buffers
double     ind_Buffer1[];
double     ind_Buffer2[];
double     ind_buffer3a[];
double     ind_buffer3b[];
double     ind_buffer4[];
double     ind_buffer5[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  string FastMAname, SlowMAname, SignalMAname;
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(6);
//---- drawing settings

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(0,SignalMA);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalMA);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ind_Buffer1);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ind_Buffer2);
   
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   
//---- 5 indicator buffers mapping
   if(!SetIndexBuffer(0,ind_buffer3a) &&
      !SetIndexBuffer(1,ind_buffer3b) &&
      !SetIndexBuffer(2,ind_buffer4) &&      
      !SetIndexBuffer(3,ind_buffer5) &&
      !SetIndexBuffer(4,ind_Buffer1) &&      
      !SetIndexBuffer(5,ind_Buffer2))
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   switch(FastMA_Method)
     {
      case 1 : FastMAname="EMA";  break;
      case 2 : FastMAname="SMMA"; break;
      case 3 : FastMAname="LWMA"; break;
      default :
         FastMA_Method=0;
         FastMAname="SMA";
     }
   switch(SlowMA_Method)
     {
      case 1 : SlowMAname="EMA";  break;
      case 2 : SlowMAname="SMMA"; break;
      case 3 : SlowMAname="LWMA"; break;
      default :
         SlowMA_Method=0;
         SlowMAname="SMA";
     }
   switch(SignalMA_Method)
     {
      case 1 : SignalMAname="EMA";  break;
      case 2 : SignalMAname="SMMA"; break;
      case 3 : SignalMAname="LWMA"; break;
      default :
         SlowMA_Method=0;
         SignalMAname="SMA";
     }
   IndicatorShortName("MACD ["+FastMAname+"("+FastMA+"),"+SlowMAname+"("+SlowMA+"),"+SignalMAname+"("+SignalMA+")]");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      ind_buffer4[i]=iMA(NULL,0,FastMA,0,FastMA_Method,PRICE_CLOSE,i)
                        -iMA(NULL,0,SlowMA,0,SlowMA_Method,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++)
      ind_buffer5[i]=iMAOnArray(ind_buffer4,Bars,SignalMA,0,SignalMA_Method,i);
//---- main loop
   double value=0;
   for(i=0; i<limit; i++)
      {
         ind_buffer3a[i]=0.0;
         ind_buffer3b[i]=0.0;      
         value=ind_buffer4[i]-ind_buffer5[i];
         if (value>0) ind_buffer3a[i]=value;
         if (value<0) ind_buffer3b[i]=value;
      }   
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

